Leetcode 3255. Find the Power of K-Size Subarrays II

  • [Leetcode 3255. Find the Power of K-Size Subarrays II](#Leetcode 3255. Find the Power of K-Size Subarrays II)
    • [1. 解题思路](#1. 解题思路)
    • [2. 代码实现](#2. 代码实现)

1. 解题思路

这一题是题目3254的进阶版,其实主要就是增加了算法复杂度。

整体上来说的话思路还是一个分段的思路,我们找到所有的满足条件的连续递增数列,显然他们之间不可能有交集。

然后,对于任何一个连续递增的数列,假设其长度为 m m m,如果 m < k m<k m<k,那显然无法构成长度不少于 k k k的数组,因此我们返回一个长度为 m m m的 − 1 -1 −1的数组即可,反之如果 m ≥ k m \geq k m≥k,那么其返回结果的前 k − 1 k-1 k−1个值就是 − 1 -1 −1,后面则就是原始数组当中的值了。

我们将所有数组拼凑在一起,然后去除掉前 k − 1 k-1 k−1个元素即为我们最终的解答了。

2. 代码实现

给出python代码实现如下:

python 复制代码
class Solution:
    def resultsArray(self, nums: List[int], k: int) -> List[int]:
        n = len(nums)
        i = 0
        ans = []
        while i < n:
            j = i
            while j < n-1 and nums[j+1] == nums[j]+1:
                j += 1
            m = j-i+1
            if m >= k:
                ans += [-1] * (k-1) + nums[i+k-1:j+1]
            else:
                ans += [-1] * m
            i = j+1
        return ans[k-1:]

提交代码评测得到:耗时1312ms,占用内存32.9MB。

相关推荐
夏幻灵10 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
Navigator_Z12 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
圣保罗的大教堂13 小时前
leetcode 301. 删除无效的括号 困难
leetcode
夏幻灵15 小时前
每日一题:LeetCode 206:反转链表——三指针与原地反转详解
算法·leetcode·链表
Tisfy18 小时前
LeetCode 0301.删除无效的括号:二进制枚举 / 回溯
算法·leetcode·字符串·题解·回溯·括号匹配·二进制枚举
Nil20819 小时前
leetcode 322零钱兑换
算法·leetcode·职场和发展
yi01119 小时前
DAY24: LeetCode 167:两数之和 II|从暴力枚举到左右双指针
笔记·python·算法·leetcode·二分查找·双指针
木井巳19 小时前
【BFS 解决拓扑排序】课程表
java·算法·leetcode·广度优先·宽度优先·推荐算法·图搜索算法
yi01119 小时前
LeetCode 15:三数之和|排序 + 双指针,如何避免重复答案?
笔记·python·算法·leetcode·双指针
alphaTao20 小时前
LeetCode 每日一题 2026/10/5-2026/10/11
算法·leetcode